KDE 4.7 PyKDE API Reference

- KDE's Python API

# KCModule Class Reference

`from PyKDE4.kdeui import *`

Inherits: QWidget → QObject

## Detailed Description

The base class for configuration modules.

Configuration modules are realized as plugins that are loaded only when needed.

The module in principle is a simple widget displaying the item to be changed. The module has a very small interface.

All the necessary glue logic and the GUI bells and whistles are provided by the control center and must not concern the module author.

To write a config module, you have to create a library that contains a factory function like the following:

     #include <KPluginFactory>

     K_PLUGIN_FACTORY(MyKCModuleFactory, registerPlugin<MyKCModule>() )
     K_EXPORT_PLUGIN(MyKCModuleFactory("yourLibName","name_of_the_po_file") )

The optional parameter "name_of_the_po_file" has to correspond with the messages target that containst the strings to be translated. Instead of using the library name for yourLibName you can also use another name which you specify in the desktop file with X-KDE-FactoryName. This is useful to have more than one factory in one lib.

The constructor of the KCModule then looks like this:

     YourKCModule.YourKCModule( QWidget* parent )
       : KCModule( YourKCModuleFactory.componentData(), parent )
     {
       KAboutData *about = new KAboutData(
         <kcm name>, 0, ki18n( "..." ),
         KDE_VERSION_STRING, KLocalizedString(), KAboutData.License_GPL,
         ki18n( "Copyright 2006 ..." ) );
       about->addAuthor( ki18n(...) );
       setAboutData( about );
       .
       .
       .
     }

If you want to make the KCModule available only conditionally (i.e. show in the list of available modules only if some test succeeds) then you can use Hidden in the .desktop file. An example:

     Hidden[$e]=$(if test -e /dev/js*; then echo "false"; else echo "true"; fi)

The example executes the given code in a shell and uses the stdout output for the Hidden value (so it's either Hidden=true or Hidden=false).

See http://developer.kde.org/documentation/other/kcm_howto.html for more detailed documentation.

Author:
  Matthias Hoelzer-Kluepfel <hoelzer@kde.org>

## Enumerations
Button | { NoAdditionalButton, Help, Default, Apply, Export }
## Signals
| changed (bool state)
| quickHelpChanged ()
| rootOnlyMessageChanged (bool use, QString message)
## Methods
| __init__ (self, KComponentData componentData, QWidget parent=0, [QVariant] args=QVariantList())
KAboutData | aboutData (self)
KConfigDialogManager | addConfig (self, KConfigSkeleton config, QWidget widget)
KConfigDialogManager | addConfig (self, KCoreConfigSkeleton config, QWidget widget)
KAuth.Action | authAction (self)
| authStatusChanged (self, int a0)
KCModule.Buttons | buttons (self)
| changed (self)
KComponentData | componentData (self)
[KConfigDialogManager] | configs (self)
| defaults (self)
QString | exportText (self)
| load (self)
bool | managedWidgetChangeState (self)
bool | needsAuthorization (self)
QString | quickHelp (self)
QString | rootOnlyMessage (self)
| save (self)
| setAboutData (self, KAboutData about)
| setButtons (self, KCModule.Buttons btn)
| setExportText (self, QString a0)
| setNeedsAuthorization (self, bool needsAuth)
| setQuickHelp (self, QString help)
| setRootOnlyMessage (self, QString message)
| setUseRootOnlyMessage (self, bool on)
| showEvent (self, QShowEvent ev)
| unmanagedWidgetChangeState (self, bool a0)
bool | useRootOnlyMessage (self)
| widgetChanged (self)

## Signal Documentation

changed | ( | bool | state
| ) |  |  |

Calling this slot is equivalent to emitting changed(true).

Signal syntax:
  `QObject.connect(source, SIGNAL("changed(bool)"), target_slot)`

quickHelpChanged | ( |  | ) |

Indicate that the module's quickhelp has changed.

Emit this signal whenever the module's quickhelp changes. Modules implemented as tabbed dialogs might want to implement per-tab quickhelp for example.

Signal syntax:
  `QObject.connect(source, SIGNAL("quickHelpChanged()"), target_slot)`

rootOnlyMessageChanged | ( | bool | use,
|  | QString | message
| ) |  |  |

Indicate that the module's root message has changed.

Emits this signal whenever the module's root message changes.

Since:
  4.4

Signal syntax:
  `QObject.connect(source, SIGNAL("rootOnlyMessageChanged(bool, QString)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | KComponentData | componentData,
|  | QWidget | parent=0,
|  | [QVariant] | args=QVariantList()
| ) |  |  |

Base class for all KControlModules.

Note:
  do not emit changed signals here, since they are not yet connected to any slot.

KAboutData aboutData | ( |  | self ) |

This is generally only called for the KBugReport. If you override you should have it return a pointer to a constant.

Returns:
  the KAboutData for this module

KConfigDialogManager addConfig | ( | self, |
|  | KConfigSkeleton | config,
|  | QWidget | widget
| ) |  |  |

Adds a KConfigskeleton config to watch the widget widget

This function is useful if you need to handle multiple configuration files.

Returns:
  a pointer to the KConfigDialogManager in use

Parameters:

  | config | the KConfigSkeleton to use
  | widget | the widget to watch

KConfigDialogManager addConfig | ( | self, |
|  | KCoreConfigSkeleton | config,
|  | QWidget | widget
| ) |  |  |

Adds a KConfigskeleton config to watch the widget widget

This function is useful if you need to handle multiple configuration files.

Returns:
  a pointer to the KConfigDialogManager in use

Parameters:

  | config | the KConfigSkeleton to use
  | widget | the widget to watch

KAuth.Action authAction | ( |  | self ) |

Returns the action previously set with setAuthAction(). By default its an invalid action.

Returns:
  The action that has to be authorized to execute the save() method.

authStatusChanged | ( | self, |
|  | int | a0
| ) |  |  |

The status of the auth action, if one, has changed

KCModule.Buttons buttons | ( |  | self ) |

Indicate which buttons will be used.

The return value is a value or'ed together from the Button enumeration type.

See also:
  KCModule.setButtons

changed | ( |  | self ) |

Calling this slot is equivalent to emitting changed(true).

KComponentData componentData | ( |  | self ) |

[KConfigDialogManager] configs | ( |  | self ) |

Returns:
  a list of KConfigDialogManager's in use, if any.

defaults | ( |  | self ) |

Sets the configuration to sensible default values.

This method is called when the user clicks the "Default" button. It should set the display to useful values.

If you use KConfigXT, you do not have to reimplement this function since the fetching and settings of default values is done automatically. However, if you reimplement and also are using KConfigXT, remember to call the base function at the very end of your reimplementation.

QString exportText | ( |  | self ) |

Returns the value set by setExportText();

load | ( |  | self ) |

Load the configuration data into the module.

The load method sets the user interface elements of the module to reflect the current settings stored in the configuration files.

This method is invoked whenever the module should read its configuration (most of the times from a config file) and update the user interface. This happens when the user clicks the "Reset" button in the control center, to undo all of his changes and restore the currently valid settings. It is also called right after construction.

bool managedWidgetChangeState | ( |  | self ) |

Returns the changed state of automatically managed widgets in this dialog

bool needsAuthorization | ( |  | self ) |

Returns the value previously set with setNeedsAuthorization(). By default it's false.

Returns:
  true if the module's save() method requires authorization, false otherwise

QString quickHelp | ( |  | self ) |

Return a quick-help text.

This method is called when the module is docked. The quick-help text should contain a short description of the module and links to the module's help files. You can use QML formatting tags in the text.

Note:
  make sure the quick help text gets translated (use i18n()).

QString rootOnlyMessage | ( |  | self ) |

Get the RootOnly message for this module.

When the module must be run as root, or acts differently for root and a normal user, it is sometimes useful to customize the message that appears at the top of the module when used as a normal user. This function returns this customized message. If none has been set, a default message will be used.

See also:
  KCModule.setRootOnlyMessage

save | ( |  | self ) |

Save the configuration data.

The save method stores the config information as shown in the user interface in the config files.

If necessary, this method also updates the running system, e.g. by restarting applications. This normally does not apply for KSettings.Dialog modules where the updating is taken care of by KSettings.Dispatcher.

save is called when the user clicks "Apply" or "Ok".

If you use KConfigXT, saving is taken care off automatically and you do not need to load manually. However, if you for some reason reimplement it and also are using KConfigXT, you must call this function, otherwise the saving of KConfigXT options will not work. Call it at the very end of your reimplementation, to avoid changed() signals getting emitted when you modify widgets.

setAboutData | ( | self, |
|  | KAboutData | about
| ) |  |  |

This sets the KAboutData returned by aboutData()

setButtons | ( | self, |
|  | KCModule.Buttons | btn
| ) |  |  |

Sets the buttons to display.

Help: shows a "Help" button.

Default: shows a "Use Defaults" button.

Apply: in kcontrol this will show an "Apply" and "Reset" button, in kcmshell this will show an "Ok", "Apply" and "Cancel" button.

If Apply is not specified, kcmshell will show a "Close" button.

See also:
  KCModule.buttons

setExportText | ( | self, |
|  | QString | a0
| ) |  |  |

Sets the export QString value, used for exporting data.

setNeedsAuthorization | ( | self, |
|  | bool | needsAuth
| ) |  |  |

Set if the module's save() method requires authorization to be executed.

The module can set this property to true if it requires authorization. It will still have to execute the action itself using the KAuth library, so this method is not technically needed to perform the action, but using this and/or the setAuthAction() method will ensure that hosting applications like System Settings or kcmshell behave correctly.

Called with true, this method will set the action to "org.kde.kcontrol.name.save" where "name" is aboutData()->appName() return value. This default action won't be set if the aboutData() object is not valid.

Note that called with false, this method will reset the action name set with setAuthAction().

Parameters:

  | needsAuth | Tells if the module's save() method requires authorization to be executed.

setQuickHelp | ( | self, |
|  | QString | help
| ) |  |  |

Sets the quick help.

setRootOnlyMessage | ( | self, |
|  | QString | message
| ) |  |  |

Sets the RootOnly message.

This message will be shown at the top of the module if useRootOnlyMessage is set. If no message is set, a default one will be used.

See also:
  KCModule.rootOnlyMessage

setUseRootOnlyMessage | ( | self, |
|  | bool | on
| ) |  |  |

Change whether or not the RootOnly message should be shown.

Following the value of on, the RootOnly message will be shown or not.

See also:
  KCModule.useRootOnlyMessage

showEvent | ( | self, |
|  | QShowEvent | ev
| ) |  |  |

unmanagedWidgetChangeState | ( | self, |
|  | bool | a0
| ) |  |  |

Call this method when your manually managed widgets change state between changed and not changed

bool useRootOnlyMessage | ( |  | self ) |

Tell if KControl should show a RootOnly message when run as a normal user.

In some cases, the module don't want a RootOnly message to appear (for example if it has already one). This function tells KControl if a RootOnly message should be shown

See also:
  KCModule.setUseRootOnlyMessage

widgetChanged | ( |  | self ) |

A managed widget was changed, the widget settings and the current settings are compared and a corresponding changed() signal is emitted

## Enumeration Documentation

Button

An enumeration type for the buttons used by this module. You should only use Help, Default and Apply. The rest is obsolete. NoAdditionalButton can be used when we do not want have other button that Ok Cancel

See also:
  KCModule.buttons
  See also:
    KCModule.setButtons
  Enumerator:

    Add = 0x0001 |
    Remove = 0x0002 |
    UpDown = 0x0004 |
    All = Add|Remove|UpDown |